function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import * as infernoStuff from 'inferno';
import Component from 'inferno-component';
import { onScrollTo, delay, debug } from 'micro-ui-utilities';
import './micro-ui-image.scss';

var SCROLL_THRESHOLD = 200;
var IMAGE_LOAD_DELAY = 100;

import { createVNode } from 'inferno';
export var MCImage = function (_Component) {
    _inherits(MCImage, _Component);

    function MCImage() {
        _classCallCheck(this, MCImage);

        return _possibleConstructorReturn(this, _Component.apply(this, arguments));
    }

    MCImage.prototype.componentDidMount = function componentDidMount() {
        var _this2 = this;

        this.handleMissingDimensions();

        delay(IMAGE_LOAD_DELAY).then(function () {
            return onScrollTo(_this2._vNode.dom, SCROLL_THRESHOLD);
        }).then(function () {
            return _this2.loadImage(_this2.props.src);
        }).then(function () {
            return _this2.setState(function () {
                return _this2.props.loadedImage = _this2.props.src;
            });
        });
    };

    MCImage.prototype.render = function render() {
        return createVNode(2, 'img', 'mc-image ' + (this.props.class ? this.props.class : '') + (this.props.loadedImage ? ' loaded' : ''), null, {
            'src': this.props.loadedImage,
            'width': this.props.width,
            'height': this.props.height
        });
    };

    MCImage.prototype.loadImage = function loadImage(src) {
        return new Promise(function (resolve) {
            var image = new Image();
            image.onload = resolve;
            image.src = src;
        });
    };

    MCImage.prototype.handleMissingDimensions = function handleMissingDimensions() {
        if (!this.props.width || !this.props.height) {
            debug.warn('If possible, add a width/height attribute to the image: ' + this.props.src + '.');
            debug.warn('This provides a better user experience as it stops content from moving around as images load in.');
        }
    };

    return MCImage;
}(Component);